unit Dial01;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls, Buttons,Inifiles,
  Declare;

type
  TDlg01 = class(TForm)
    OK: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    ST: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  public
    //FichierINI : string;
    LHost : TList;
  end;


implementation

{$R *.dfm}

procedure TDlg01.FormCreate(Sender: TObject);
var i : integer;
begin
  ST.Cells[1,0] := 'IP ou nom DNS';
  ST.Cells[2,0] := 'Nom du Bouton';
  ST.Cells[3,0] := 'Mail';
  ST.ColWidths[1] := 100;
  ST.ColWidths[1] := 150;
  ST.ColWidths[3] := 220;
  ST.RowCount := max_Host + 1;
  for i := 0 to max_Host do ST.Cells[0,i+1] := 'Bouton n ' + IntToStr (i+1);
end;

procedure TDlg01.FormShow(Sender: TObject);
var i : integer;
    H : THost;
begin
  for i := 0 to max_Host - 1 do
  begin
    H := LHost.Items[i];
    ST.Cells[1,i+1] := H.IP;
    ST.Cells[2,i+1] := H.Name;
    ST.Cells[3,i+1] := H.Mail;
  end;
end;

procedure TDlg01.OKClick(Sender: TObject);
var i : integer;
    H : THost;
    F : TIniFile;

    procedure Local_EcrireHost (var Ho:THost;Ind:integer);
    begin
      F.WriteString (Sec_Host,id_name + IntToStr (Ind),Ho.Name);
      F.WriteString (Sec_Host,id_ip + IntToStr (Ind),Ho.IP);
      F.WriteString (Sec_Host,id_mail + IntToStr (Ind),Ho.Mail);
    end;

begin
  for i := 0 to max_Host -1 do
  begin
    H := LHost.Items[i];
    H.IP := ST.Cells[1,i+1];
    H.Name := ST.Cells[2,i+1];
    H.Mail := ST.Cells[3,i+1];
  end;
  F := TIniFile.Create (FichierINI);
  for i := 0 to max_Host -1  do
  begin
    H := LHost.Items[i];
    Local_EcrireHost (H,i);
  end;
  F.Free;
end;



end.
