unit PingTst1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls,journal, Buttons,IniFiles,
  Declare,
  Dial01,Dial03, apropos,
  c_RxTimer, OverbyteIcsWndControl,
  OverbyteIcsPing;

type

  TForm1 = class(TForm)
    Ping1: TPing;
    Timer1: TTimer;
    Btn_Start: TButton;
    Btn_Stop: TButton;
    RE: TRichEdit;
    Btn_Clear: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel0: TPanel;
    PanelInfo: TPanel;
    Btn_Config: TButton;
    Button1: TButton;
    Label_Time: TLabel;
    Button2: TButton;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Button3: TButton;
    Label_Date: TLabel;
    RxTimer1: TRxTimer;
    BitBtn1: TBitBtn;
    CBAuto: TCheckBox;
    Label1: TLabel;
    procedure Ping1DnsLookupDone(Sender: TObject; Error: Word);
    procedure Ping1EchoRequest(Sender: TObject; Icmp: TObject);
    procedure Ping1EchoReply(Sender: TObject; Icmp: TObject; Error: Integer);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Btn_StartClick(Sender: TObject);
    procedure Btn_StopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Btn_ClearClick(Sender: TObject);
    procedure Btn_ConfigClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    LHost:TList;
    Index : integer;
    //NbEchec:Array[0..max_Host-1] of integer;
    function GetPanel (AIndex:integer):TPanel;
    procedure InitHost;
    procedure InitPanel;
    procedure InitUnPanel (P:TPanel;Mode:TModePanel);
    property Panel[AIndex:integer]:TPanel read GetPanel;
    procedure LireCBAuto;
    procedure EcrireCBAuto;
    procedure InitNbEchec;
  end;


var
  Form1: TForm1;

implementation

uses Dial02;

{$R *.DFM}
procedure TForm1.FormCreate(Sender: TObject);
begin
  LHost := TList.Create;
  Index    := -1;
  InitNbEchec;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  InitHost;
  InitPanel;
  LireCBAuto;
  if CBAuto.Checked then Btn_StartClick(Sender);
end;

procedure TForm1.Ping1DnsLookupDone(Sender: TObject; Error: Word);
var H : THost;
begin
  H := LHost.Items[Index];
  if Error <> 0 then
  begin
    InitUnPanel (Panel[Index],mNoOK);
    Journal_Texte (RE,'Hte non rsolu:' + H.Name,clRed,[]);
    Exit;
  end;
  Journal_Texte (RE,'Hte rsolu: ' + H.Name + ' - ' + Ping1.DnsResult,clBlack,[]);
  Application.ProcessMessages;
  Ping1.Address := Ping1.DnsResult;
  Ping1.Ping;
end;

procedure TForm1.Ping1EchoRequest(Sender: TObject; Icmp: TObject);
begin
   Journal_Texte (RE,'Envoi: ' + IntToStr(Ping1.Size) + ' octets  ' + Ping1.HostName + ' (' + Ping1.HostIP + ')',clBlack,[]);
end;

procedure TForm1.Ping1EchoReply(Sender: TObject; Icmp: TObject; Error: Integer);
var H : THost;
    OldMode : tModePanel;
    OldNbEchec:integer;
begin
  H := LHost.Items[Index];
  OldMode := H.Mode;
  if Error = 0 then
  begin
    H.Mode := mNoOK;
    if H.NbEchec = 0 then H.HeureDebut := DateDuJour + ' / ' + TimeToStr (Now);
    Inc (H.NbEchec);
    InitUnPanel (Panel[Index],mNoOK);
    Journal_Texte (RE,'Pas de rponse de ' + Ping1.HostIP + ' : ' + Ping1.ErrorString,clRed,[fsBold])
  end else
  begin
    H.Mode := mOK;
    OldNbEchec := H.NbEchec;
    H.NbEchec := 0;
    H.HeureFin := DateDuJour + ' / ' + TimeToStr (Now);
    InitUnPanel (Panel[Index],mOK);
    Journal_Texte (RE,'Rponse ' + IntToStr(Ping1.Reply.DataSize) +
                              ' octets de ' + Ping1.HostIP +
                              ' en ' + IntToStr(Ping1.Reply.RTT) + ' msecs',clGreen,[fsBold]);
  end;
  // Envoi d'un mail d'alerte : Ne rpond plus & NbEchec atteind
  if (H.Mail <> vide) and (H.NbEchec >= Dlg03.NbEchec)
  and (H.Mode = mNoOK) then
  begin
    if not H.MailEnvoye then
    begin
      with Dlg03 do
      begin
        ModeSMTP := mErreur;
        Mail_Subject := '[Ping Rafale] '+ H.Name + ' : Ne rpond plus';
        Mail_To := H.Mail;
        Mail_Body1 := H.Name + ' - ' + H.IP;
        Mail_Body2 := 'Cet hote ne rpond plus / Nombre d''chec(s) conscutif(s): ' + IntToStr (H.NbEchec);
        Mail_Body3 := vide;
        Mail_Body4 := vide;
        EnvoyerMail;
      end;
      Journal_Texte (RE,'Envoi mail d''alerte [ Ne rpond plus ] : ' + H.Mail,clRed,[fsBold]);
      H.MailEnvoye := true;
    end;
  end;

  // Envoi d'un mail d'alerte : Rpond  nouveau
  if (H.Mail <> vide) and  ( (OldMode = mNoOK) and (H.Mode = mOK) ) then
  begin
    with Dlg03 do
    begin
      ModeSMTP := mErreur;
      Mail_Subject := '[Ping Rafale] '+ H.Name + ' : Rpond  nouveau';
      Mail_To := H.Mail;
      Mail_Body1 := H.Name + ' - ' + H.IP;
      Mail_Body2 := 'Cet hote rpond  nouveau / Aprs ' + IntToStr (OldNbEchec) + ' chec(s) conscutif(s)';
      Mail_Body3 := 'Dbut du disfonctionnement : ' + H.HeureDebut;
      Mail_Body4 := 'Fin du disfonctionnement : ' + H.HeureFin;
      EnvoyerMail;
      H.MailEnvoye := false;
    end;
    Journal_Texte (RE,'Envoi mail d''alerte [ Rpond  nouveau] : ' + H.Mail,clRed,[fsBold]);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var H : THost;
begin
  Inc (Index);
  if Index >= LHost.Count then Index := 0;
  H := LHost.Items[Index];
  if H.Name = vide then
  begin
    Index := 0;
    H := LHost.Items[Index];
  end;
  Journal_LigneVide (RE);
  Journal_Texte (RE,'Rsolution DNS: ' + H.IP + ' - ' + H.Name,clBlack,[]);
  PanelInfo.Caption := 'En cours : ' + H.Name +  ' - ' + H.IP;
  InitUnPanel (Panel[Index],mEnCours);
  Application.ProcessMessages;
  Ping1.DnsLookup(H.IP);
end;

procedure TForm1.Btn_StartClick(Sender: TObject);
begin
  Btn_Config.Enabled := false;
  InitPanel;
  Index := -1;
  Timer1.Enabled := true;
  Journal_Titre (RE,'Dmarrage des pings',IntToStr (LHost.Count) + ' htes  pinger');
end;

procedure TForm1.Btn_StopClick(Sender: TObject);
begin
  Btn_Config.Enabled := true;
  Timer1.Enabled := false;
  Journal_Titre (RE,'Arrt des pings',vide);
  PanelInfo.Caption := 'Arrt';
end;

function TForm1.GetPanel (AIndex:integer):TPanel;
var i : integer;
begin
  Result := nil;
  for i := 0 to ComponentCount - 1 do
  begin
    if (Components[i] is TPanel) and (Components[i].Tag = AIndex)
      then Result := Components[i] as TPanel;
  end;
end;

procedure TForm1.InitPanel;
var P : TPanel;
    i : integer;
    H : THost;
begin
  for i := 0 to LHost.Count - 1 do
  begin
    P := Panel[i];
    H := LHost.Items[i];
    if P <> nil then
    begin
      P.Caption := H.Name;
      InitUnPanel(P,mInit);
    end;
  end;
end;

procedure TForm1.InitUnPanel (P:TPanel;Mode:TModePanel);
begin
  if P <> nil then
  case Mode of
  mInit : begin
            P.Font.Size := 10;
            P.Font.Color := clBlack;
            P.Font.Style := [];
            P.Color := clBtnFace;
          end;
  mEnCours : begin
            P.Font.Color := clBlack;
            P.Font.Style := [fsBold];
            P.Color := clYellow;
           end;
  mOK : begin
            P.Font.Color := clBlack;
            P.Font.Style := [fsBold];
            P.Color := clGreen;
        end;
  mNoOK : begin
            P.Font.Color := clBlack;
            P.Font.Style := [fsBold];
            P.Color := clRed;
          end;
  end;
end;

procedure TForm1.InitHost;
var F : TIniFile;
    i : integer;
    H : THost;

    procedure Local_LireHost (var Ho:THost;Ind:integer);
    begin
      Ho.Name := F.ReadString (Sec_Host,id_name + IntToStr (Ind),vide);
      Ho.IP   := F.ReadString (Sec_Host,id_ip + IntToStr (Ind),vide);
      Ho.Mail := F.ReadString (Sec_Host,id_mail + IntToStr (Ind),vide);
    end;

begin
  F := TIniFile.Create(FichierINI);
  for i := 0 to max_Host - 1 do
  begin
    H := THost.Create;
    Local_LireHost(H,i);
    H.Mode := mInit;
    LHost.Add(H);
  end;
  F.Free;
end;    

procedure TForm1.InitNbEchec;
var i : integer;
    H : THost;
begin
  for i := 0 to LHost.Count - 1 do
  begin
    H := LHost.Items[i];
    H.NbEchec := 0;
    H.MailEnvoye := false;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var H : THost;
    i : integer;
begin
  for i := 0 to LHost.Count - 1 do
  begin
    H := LHost.Items[i];
    H.Free;
  end;
  LHost.Free;
  EcrireCBAuto;
end;

procedure TForm1.Btn_ClearClick(Sender: TObject);
begin
  RE.Clear;
end;

procedure TForm1.Btn_ConfigClick(Sender: TObject);
var Dlg : TDlg01;
begin
  Dlg := TDlg01.Create (Self);
  Dlg.LHost := LHost;
  if Dlg.ShowModal = mrOK then InitPanel;
  Dlg.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Dlg: TDlgAPropos;
begin
  Dlg := TDlgAPropos.Create (Self);
  Dlg.ShowModal;
  Dlg.Free;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Label_Time.Caption := TimeToStr (Now);
  Label_Date.Caption := DateDuJour;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // provisoire bug2012

  ShowMessage ('Synchronisation de l''horloge : Fonction neutralise');
  Exit;

  // Commentaire EY Pascal, mars 2012 :
  // le code de l'unit Dlg02 ne fonctionne plus sous D2007 et
  // doit tre remplac par un autre client SNTP...
  // Le sous dossier client SNTP contient un tel composant, mais non test.
  // Voir aussi:
  // http://svaillant.developpez.com/delphi_datetime/?page=page_IV



  Dlg02.ShowModal;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Dlg03.ShowModal;
end;

procedure TForm1.LireCBAuto;
var F : TIniFile;
begin
  F := TIniFile.Create(FichierINI);
  CBAuto.Checked := F.ReadBool(Self.Name,id_auto,false);
  F.Free;
end;

procedure TForm1.EcrireCBAuto;
var F : TIniFile;
begin
  F := TIniFile.Create(FichierINI);
  F.WriteBool(Self.Name,id_auto,CBAuto.Checked);
  F.Free;
end;

end.

