unit Dial03;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, IniFiles,Declare,
  OverbyteIcsWndControl, OverbyteIcsSmtpProt,
  ExtCtrls, c_SaisieNombre;
//  OverbyteIcsWndControl, OverbyteIcsSmtpProt;
//  OverbyteIcsWndControl, OverbyteIcsSmtpProt;

type

  TModeSMTP = (mTest,mErreur);

  TDlg03 = class(TForm)
    OK: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    HostEdit: TEdit;
    Label4: TLabel;
    PortEdit: TEdit;
    ToEdit: TEdit;
    Label3: TLabel;
    FromEdit: TEdit;
    Label2: TLabel;
    Label12: TLabel;
    CcEdit: TEdit;
    Label13: TLabel;
    BccEdit: TEdit;
    SignOnEdit: TEdit;
    Label8: TLabel;
    SubjectEdit: TEdit;
    Subject: TLabel;
    Label9: TLabel;
    UsernameEdit: TEdit;
    Label10: TLabel;
    PasswordEdit: TEdit;
    AuthComboBox: TComboBox;
    Label11: TLabel;
    Label14: TLabel;
    PriorityComboBox: TComboBox;
    ConfirmCheckBox: TCheckBox;
    Button1: TButton;
    SmtpClient: TSmtpCli;
    DisplayMemo: TMemo;
    SNNbEchec: TSaisieNombre;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure SmtpClientDisplay(Sender: TObject; Msg: String);
    procedure SmtpClientRequestDone(Sender: TObject; RqType: TSmtpRequest; ErrorCode: Word);
    procedure SmtpClientGetData(Sender: TObject; LineNum: Integer;MsgLine: Pointer; MaxLen: Integer; var More: Boolean);
  public
    ModeSMTP : TModeSMTP;
    Mail_Subject,
    Mail_To,
    Mail_Body1,
    Mail_Body2,
    Mail_Body3,
    Mail_Body4 : string;
    NbEchec : integer;
    procedure EnvoyerMail;
  private
    procedure LireINI;
    procedure EcrireINI;
    procedure Display (Msg:string);
  end;

var
  Dlg03: TDlg03;

implementation

{$R *.dfm}

const
    SectionData       = 'Data';
    KeyHost           = 'HostName';
    KeyPort           = 'Port';
    KeyFrom           = 'From';
    KeyTo             = 'To';
    KeyCc             = 'Cc';
    KeyBcc            = 'Bcc';
    KeySubject        = 'Subject';
    KeySignOn         = 'SignOn';
    KeyUser           = 'UserName';
    KeyPass           = 'Password';
    KeyAuth           = 'Authentification';
    KeyPriority       = 'Priority';
    KeyConfirm        = 'Confirm';
    SectionWindow     = 'Window';
    KeyTop            = 'Top';
    KeyLeft           = 'Left';
    KeyWidth          = 'Width';
    KeyHeight         = 'Height';
    SectionFileAttach = 'Files';
    KeyFileAttach     = 'File';
    SectionMsgMemo    = 'Message';
    KeyMsgMemo        = 'Msg';
    KeyNbEchec        = 'NbEchec';

procedure TDlg03.LireINI;
var
    IniFile : TIniFile;
begin
        IniFile := TIniFile.Create(FichierINI);
        HostEdit.Text    := IniFile.ReadString(SectionData, KeyHost,
                                               'Serveur SMTP');
        PortEdit.Text    := IniFile.ReadString(SectionData, KeyPort,
                                               '25');
        FromEdit.Text    := IniFile.ReadString(SectionData, KeyFrom,
                                               'Expediteur');
        ToEdit.Text      := IniFile.ReadString(SectionData, KeyTo,
                                               '');
        CcEdit.Text      := IniFile.ReadString(SectionData, KeyCc,
                                               '');
        BccEdit.Text     := IniFile.ReadString(SectionData, KeyBcc,
                                               '');
        SubjectEdit.Text := IniFile.ReadString(SectionData, KeySubject,
                                               '[Ping Rafale] - Message TEST');
        SignOnEdit.Text  := IniFile.ReadString(SectionData, KeySignOn,
                                               'Votre nom');
        UsernameEdit.Text :=  IniFile.ReadString(SectionData, KeyUser,
                                               'compte (nom)');
        PasswordEdit.Text      :=  IniFile.ReadString(SectionData, KeyPass,
                                               'compte (password)');
        AuthComboBox.ItemIndex     := IniFile.ReadInteger(SectionData, KeyAuth, 0);
        PriorityComboBox.ItemIndex := IniFile.ReadInteger(SectionData, KeyPriority, 2);
        ConfirmCheckBox.Checked    := Boolean(IniFile.ReadInteger(SectionData, KeyConfirm, 0));

        NbEchec := IniFile.ReadInteger (SectionData,KeyNbEchec,1);
        SNNbEchec.ValeurI := NbEchec;

(*        if not LoadStringsFromIniFile(FIniFileName, SectionFileAttach,
                                      KeyFileAttach, FileAttachMemo.Lines) then
        FileAttachMemo.Text := vide;
        if not LoadStringsFromIniFile(FIniFileName, SectionMsgMemo,
                                      KeyMsgMemo, MsgMemo.Lines) then
            MsgMemo.Text :=
            'This is the first line' + #13#10 +
            'Then the second one' + #13#10 +
            'The next one is empty' + #13#10 +
            '' + #13#10 +
            'The next one has only a single dot' + #13#10 +
            '.' + #13#10 +
            'Finally the last one' + #13#10;
        Top    := IniFile.ReadInteger(SectionWindow, KeyTop,    (Screen.Height - Height) div 2);
        Left   := IniFile.ReadInteger(SectionWindow, KeyLeft,   (Screen.Width - Width) div 2);
        Width  := IniFile.ReadInteger(SectionWindow, KeyWidth,  Width);
        Height := IniFile.ReadInteger(SectionWindow, KeyHeight, Height);*)

        IniFile.Free;
end;

procedure TDlg03.EcrireINI;
var IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(FichierINI);
  IniFile.WriteString(SectionData, KeyHost,      HostEdit.Text);
  IniFile.WriteString(SectionData, KeyPort,      PortEdit.Text);
  IniFile.WriteString(SectionData, KeyFrom,      FromEdit.Text);
  IniFile.WriteString(SectionData, KeyTo,        ToEdit.Text);
  IniFile.WriteString(SectionData, KeyCc,        CcEdit.Text);
  IniFile.WriteString(SectionData, KeyBcc,       BccEdit.Text);
  IniFile.WriteString(SectionData, KeySubject,   SubjectEdit.Text);
  IniFile.WriteString(SectionData, KeySignOn,    SignOnEdit.Text);
  IniFile.WriteString(SectionData, KeyUser,      UsernameEdit.Text);
  IniFile.WriteString(SectionData, KeyPass,      PasswordEdit.Text);
  IniFile.WriteInteger(SectionData, KeyAuth,     AuthComboBox.ItemIndex);
  IniFile.WriteInteger(SectionData, KeyPriority, PriorityComboBox.ItemIndex);
  IniFile.WriteInteger(SectionData, KeyConfirm,  Ord(ConfirmCheckBox.Checked));
  NbEchec := SNNbEchec.ValeurI;
  IniFile.WriteInteger(SectionData, KeyNbEchec,  NbEchec);
  IniFile.Free;
end;


procedure TDlg03.FormCreate(Sender: TObject);
begin
  LireINI;
end;

procedure TDlg03.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  EcrireINI;
end;

procedure TDlg03.Button1Click(Sender: TObject);
begin
  DisplayMemo.Clear;
  ModeSMTP := mTest;
  Mail_To := ToEdit.Text;
  Mail_Subject := SubjectEdit.Text;
  EnvoyerMail;
end;

procedure TDlg03.EnvoyerMail;
begin
  SmtpClient.Host           := HostEdit.Text;
  SmtpClient.Port           := PortEdit.Text;
  SmtpClient.SignOn         := SignOnEdit.Text;
  SmtpClient.FromName       := FromEdit.Text;
  SmtpClient.HdrFrom        := FromEdit.Text;
  SmtpClient.HdrTo          := Mail_To;
  SmtpClient.HdrCc          := CcEdit.Text;
  SmtpClient.HdrSubject     := Mail_Subject;
  //SmtpClient.EmailFiles     := vide;
  SmtpClient.AuthType       := TSmtpAuthType(AuthComboBox.ItemIndex);
  SmtpClient.Username       := UsernameEdit.Text;
  SmtpClient.Password       := PasswordEdit.Text;
  SmtpClient.HdrPriority    := TSmtpPriority(PriorityComboBox.ItemIndex);
  SmtpClient.ConfirmReceipt := ConfirmCheckBox.Checked;
  { Recipient list is computed from To, Cc and Bcc fields }
  SmtpClient.RcptName.Clear;
  SmtpClient.RcptNameAdd(ToEdit.Text, CcEdit.Text, BccEdit.text);

  Display ('Connexion au server SMTP...');
  { Start first operation to do to send an email          }
  { Next operations are started from OnRequestDone event  }
  SmtpClient.Connect;
  //Label5.Caption := 'Message envoy: ' + TimeToStr (Now);

end;

procedure TDlg03.Display (Msg:string);
begin
  DisplayMemo.Lines.BeginUpdate;
  try
    if DisplayMemo.Lines.Count > 200 then begin
    { We preserve only 200 lines }
    while DisplayMemo.Lines.Count > 200 do DisplayMemo.Lines.Delete(0);
  end;
    DisplayMemo.Lines.Add(Msg);
  finally
    DisplayMemo.Lines.EndUpdate;
    { Makes last line visible }
    {$IFNDEF VER80}
    SendMessage(DisplayMemo.Handle, EM_SCROLLCARET, 0, 0);
    {$ENDIF}
  end;
end;

procedure TDlg03.SmtpClientDisplay(Sender: TObject; Msg: String);
begin
  Display(Msg);
end;

procedure TDlg03.SmtpClientRequestDone(Sender: TObject; RqType: TSmtpRequest;  ErrorCode: Word);
begin
(*    { For every operation, we display the status }
    if (Error > 0) and  (Error < 10000) then
        Display('RequestDone Rq=' + IntToStr(Ord(RqType)) +
                    ' Error='+ SmtpClient.ErrorMessage)
    else
        Display('RequestDone Rq=' + IntToStr(Ord(RqType)) +
                            ' Error='+ IntToStr(Error));
    { Check if the user has asked for "All-In-One" demo }
    if not FAllInOneFlag then
        Exit;             { No, nothing more to do here }
    { We are in "All-In-One" demo, start next operation }
    { But first check if previous one was OK            }*)
    if Error <> 0 then begin
        //FAllInOneFlag := FALSE;   { Terminate All-In-One demo }
        Display('Erreur');
        Exit;
    end;
    case RqType of
    smtpConnect:  begin
                      if SmtpClient.AuthType = smtpAuthNone then
                          SmtpClient.Helo
                      else
                          SmtpClient.Ehlo;
                  end;
    smtpHelo:     SmtpClient.MailFrom;
    smtpEhlo:     SmtpClient.Auth;
    smtpAuth:     SmtpClient.MailFrom;
    smtpMailFrom: SmtpClient.RcptTo;
    smtpRcptTo:   SmtpClient.Data;
    smtpData:     SmtpClient.Quit;
    smtpQuit:     Display('Fin');
    end;
end;

procedure TDlg03.SmtpClientGetData(Sender: TObject; LineNum: Integer; MsgLine: Pointer; MaxLen: Integer; var More: Boolean);
begin
  case ModeSMTP of
  // Btn Tester du Dlg 03
  mTest : begin
            case LineNum of
              1 : StrPCopy(MsgLine,'Ping_Rafale - Message de test');
              2 : StrPCopy(MsgLine,DateDuJour + ' - ' + TimeToStr (Now));
            else More := false;
            end;
          end;
  // Erreur de Ping
  mErreur : begin
              case LineNum of
                1 : StrPCopy(MsgLine,'Ping_Rafale - Message d''ERREUR');
                2 : StrPCopy(MsgLine,DateDuJour + ' - ' + TimeToStr (Now));
                3 : StrPCopy(MsgLine,'L''hote suivant pose problme:');
                4 : StrPCopy(MsgLine,Mail_Body1);
                5 : StrPCopy(MsgLine,Mail_Body2);
                6 : if Mail_Body3 <> vide then StrPCopy(MsgLine,Mail_Body3);
                7 : if Mail_Body4 <> vide then StrPCopy(MsgLine,Mail_Body4);
              else More := false;
              end;
            end;
  else More := false;
  end;
end;

end.
